' GetIcon.Bas by Robert McGhee 72234,333
' Derived from PIC2ICON project by Matt Hart 75450,3705
' With key modifications by Mike Murphy 71160,1275
'
'
DefInt A-Z
'
' Window API Function Declarations
'
Declare Function BitBlt Lib "Gdi" (ByVal destHdc, ByVal X, ByVal Y, ByVal w, ByVal h, ByVal srcHdc, ByVal srcX, ByVal srcY, ByVal Rop As Long)
Declare Function CreateCompatibleBitmap Lib "Gdi" (ByVal hDC, ByVal w, ByVal h)
Declare Function CreateCompatibleDC Lib "Gdi" (ByVal hDC)
Declare Function DeleteDC Lib "Gdi" (ByVal hDC)
Declare Function DeleteObject Lib "Gdi" (ByVal hObject)
Declare Function GetBitmapBits Lib "Gdi" (ByVal hBitmap, ByVal dwCount As Long, ByVal lpBits As Long) As Long
Declare Function GetDeviceCaps Lib "Gdi" (ByVal hDC, ByVal nIndex)
Declare Function GlobalLock Lib "Kernel" (ByVal mMem) As Long
Declare Function GlobalUnlock Lib "Kernel" (ByVal mMem)
Declare Function SelectObject Lib "Gdi" (ByVal hDC, ByVal hObject)
Declare Function GetPixel Lib "GDI" (ByVal hDC As Integer, ByVal X As Integer, ByVal Y As Integer) As Long
'
Declare Function GetWindowWord% Lib "User" (ByVal hWnd%, ByVal nIndex%)
Declare Function ExtractIcon% Lib "Shell" (ByVal hInst%, ByVal lpszExeName$, ByVal iIcon%)
Declare Function DrawIcon% Lib "User" (ByVal hDC%, ByVal X%, ByVal Y%, ByVal hIcon%)
'
' Window API Constant Declarations - used only within this module
'
Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Const BLACKNESS = &H42&  ' (DWORD) dest = BLACK
Const BITSPIXEL = 12
'
' Global Pointers to Form and Controls used for Icon manipulation
'
Global TForm As Form, TImage As Control, TMask As Control
Global TIcon As Control, TPic As Control
'
' Variables used only within this module
'
Dim MonohDC As Integer
Dim MonoHbm As Integer
Dim ImageSize As Integer
Dim IsTrans As Integer

Sub MakeIcon (ExeFile$)
  Dim Lpicon As Long
  If GetDeviceCaps(TForm.hDC, BITSPIXEL) = 8 Then
      ImageSize = 1024 'bytes
  Else
      ImageSize = 512  'bytes
  End If
  MonohDC = CreateCompatibleDC(TForm.hDC)
  MonoHbm = CreateCompatibleBitmap(MonohDC, 32, 32)
  OldObject = SelectObject(MonohDC, MonoHbm)

' from Icon Works - clears out image, mask and dest picture box
' not that Picture1 has an all white icon preloaded in it
  TImage.Line (0, 0)-(31, 31), &H0&, BF
  TMask.Line (0, 0)-(31, 31), &HFFFFFF, BF
  Update_Icon

  hCInst = GetWindowWord(TForm.hWnd, -6)
  hIcon = ExtractIcon(hCInst, ExeFile$, 0)
  
' double check properties of Pic_Image and Pic_Mask
  R = DrawIcon(TImage.hDC, 0, 0, hIcon)
  R = DrawIcon(TMask.hDC, 0, 0, hIcon)
' check for icon transparency - important for mono bitmap
' I know this is slow, but its the best I could come up with
' Note we use GetPixel - this api will work on pictures with
' their visibility set to false - which is what you probably
' want in a real world program. Not sure basic point will work.
  IsTrans = False
  For X% = 0 To 31
    For Y% = 0 To 31
      If GetPixel(TImage.hDC, X%, Y%) <> GetPixel(TMask.hDC, X%, Y%) Then
        IsTrans = True
        Exit For
      End If
    Next Y%
    If IsTrans Then Exit For
  Next X%

  Update_Icon
' Image controls use fewer resources and don't have BackColor to worry about
'  Image1.DragIcon = Picture1.Picture
  TIcon.Picture = TPic.Picture
  TIcon.DragIcon = TPic.Picture
' uncomment the following line to save the icon to disk
'  SavePicture TPic.Picture, App.Path & "\ext.ico"

  R = DeleteDC(MonohDC)
  R = DeleteObject(MonoHbm)
End Sub

Sub Update_Icon ()
  Dim Lpicon As Long
'depending on icon transparency we set mono bitmap one of two ways
  If IsTrans Then
    R = BitBlt(MonohDC, 0, 0, 32, 32, TImage.hDC, 0, 0, SRCCOPY)
    R = BitBlt(MonohDC, 0, 0, 32, 32, TMask.hDC, 0, 0, SRCAND)
  Else
    R = BitBlt(MonohDC, 0, 0, 32, 32, TImage.hDC, 0, 0, BLACKNESS)
  End If
  Lpicon = GlobalLock(TPic.Picture)
  R = GetBitmapBits(MonoHbm, 128, Lpicon + 12)
  R = GetBitmapBits(TImage.Image, ImageSize, Lpicon + 12 + 128)
  R = GlobalUnlock(TPic.Picture)
TPic.Cls
End Sub

